/*!
* Dynamsoft Document Scanner JavaScript Library
* @product Dynamsoft Document Scanner JS Edition Bundle
* @website http://www.dynamsoft.com
* @copyright Copyright 2025, Dynamsoft Corporation
* @author Dynamsoft
* @version 1.2.0
* @fileoverview Dynamsoft Document Scanner (DDS) is a ready-to-use SDK for capturing and enhancing document images with automatic border detection, correction, and customizable workflows. Uses Dynamsoft Capture Vision Bundle v2.6.1000.
* More info on DDS JS: https://www.dynamsoft.com/capture-vision/docs/web/programming/javascript/
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("dynamsoft-core"),require("dynamsoft-license"),require("dynamsoft-capture-vision-router"),require("dynamsoft-camera-enhancer"),require("dynamsoft-document-normalizer"),require("dynamsoft-utility")):"function"==typeof define&&define.amd?define(["exports","dynamsoft-core","dynamsoft-license","dynamsoft-capture-vision-router","dynamsoft-camera-enhancer","dynamsoft-document-normalizer","dynamsoft-utility"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).Dynamsoft=e.Dynamsoft||{},e.Dynamsoft.Core,e.Dynamsoft.License,e.Dynamsoft.CVR,e.Dynamsoft.DCE,e.Dynamsoft.DDN,e.Dynamsoft.Utility)}(this,(function(e,t,i,n,a,s,o){"use strict";function r(e){var t=Object.create(null);return e&&Object.keys(e).forEach((function(i){if("default"!==i){var n=Object.getOwnPropertyDescriptor(e,i);Object.defineProperty(t,i,n.get?n:{enumerable:!0,get:function(){return e[i]}})}})),t.default=e,Object.freeze(t)}var l,c=r(t),d=r(i),h=r(n),u=r(a),m=r(s),g=r(o);!function(e){e.Scanner="scanner",e.Result="scan-result",e.Correction="correction"}(l||(l={}));const f="DetectDocumentBoundaries_Default",p="NormalizeDocument_Default";var v,w;function C(e){if("string"==typeof e){const t=document.querySelector(e);if(!t)throw new Error("Element not found");return t}return e instanceof HTMLElement?e:null}e.EnumResultStatus=void 0,(v=e.EnumResultStatus||(e.EnumResultStatus={}))[v.RS_SUCCESS=0]="RS_SUCCESS",v[v.RS_CANCELLED=1]="RS_CANCELLED",v[v.RS_FAILED=2]="RS_FAILED",function(e){e.MANUAL="manual",e.SMART_CAPTURE="smartCapture",e.AUTO_CROP="autoCrop",e.UPLOADED_IMAGE="uploadedImage",e.STATIC_FILE="staticFile"}(w||(w={}));function y(e,t){E("dds-controls-style","\n  .dds-controls {\n    display: flex;\n    height: 8rem;\n    background-color: #323234;\n    align-items: center;\n    font-size: 12px;\n    font-family: Verdana;\n    color: white;\n    width: 100%;\n  }\n\n  .dds-control-btn {\n    background-color: #323234;\n    color: white;\n    cursor: pointer;\n    display: flex;\n    align-items: center;\n    justify-content: center;\n    flex-direction: column;\n    height: 100%;\n    width: 100%;\n    gap: 0.5rem;\n    text-align: center;\n    user-select: none;\n  }\n\n  .dds-control-btn.hide {\n    display: none;\n  }\n\n  .dds-control-btn.disabled {\n    opacity: 0.4;\n    pointer-events: none;\n    cursor: default;\n  }\n\n  .dds-control-icon-wrapper {\n    flex: 0.75;\n    display: flex;\n    align-items: flex-end;\n    justify-content: center;\n    min-height: 40px;\n  }\n\n  .dds-control-icon img,\n  .dds-control-icon svg {\n    width: 32px;\n    height: 32px;\n    fill: #fe8e14;\n  }\n\n  .dds-control-text {\n    flex: 0.5;\n    display: flex;\n    align-items: flex-start;\n    justify-content: center;\n  }\n\n  @media (orientation: landscape) and (max-width: 1024px) {\n    .dds-controls {\n      flex-direction: column;\n      height: 100%;\n      width: 8rem;\n    }\n  }\n");const i=document.createElement("div");return i.className="dds-controls",e.forEach((e=>{const t=document.createElement("div");t.id=e.id,t.className=`dds-control-btn ${null==e?void 0:e.className}`;const n=document.createElement("div");if(n.className="dds-control-icon-wrapper",(a=e.icon).trim().startsWith("<svg")&&a.trim().endsWith("</svg>"))n.innerHTML=e.icon;else{const t=document.createElement("img");t.src=e.icon,t.alt=e.label,t.width=24,t.height=24,n.appendChild(t)}var a;const s=document.createElement("div");s.className="dds-control-text",s.textContent=e.label,e.isDisabled&&t.classList.add("disabled"),e.isHidden&&t.classList.add("hide"),t.appendChild(n),t.appendChild(s),e.onClick&&!e.isDisabled&&t.addEventListener("click",e.onClick),i.appendChild(t)})),i}function R(e){return[w.SMART_CAPTURE,w.UPLOADED_IMAGE,w.MANUAL].includes(e)}function E(e,t){if(!document.getElementById(e)){const i=document.createElement("style");i.id=e,i.textContent=t,document.head.appendChild(i)}}const S=e=>!e||0===Object.keys(e).length,V={"4k":{width:3840,height:2160},"2k":{width:2560,height:1440},"1080p":{width:1920,height:1080},"720p":{width:1280,height:720},"480p":{width:640,height:480}};const b={fullImage:'\n  <svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="25" height="25" viewBox="0 0 25 25">\n  <defs>\n    <clipPath id="fullImageclip-path">\n      <rect id="Rectangle_2776" data-name="Rectangle 2776" width="25" height="25" fill="#fff"/>\n    </clipPath>\n  </defs>\n  <g id="full-image" transform="translate(0 0)">\n    <g id="Group_586" data-name="Group 586" transform="translate(0 0)" clip-path="url(#fullImageclip-path)">\n      <path id="Path_1528" data-name="Path 1528" d="M.621,3.618A.621.621,0,0,0,1.242,3V1.809a.569.569,0,0,1,.567-.567H3A.621.621,0,0,0,3,0H1.809A1.811,1.811,0,0,0,0,1.809V3a.621.621,0,0,0,.621.621" transform="translate(0 0)" fill="#fff"/>\n      <path id="Path_1529" data-name="Path 1529" d="M17.842,1.242H19.03a.568.568,0,0,1,.566.567V3a.621.621,0,1,0,1.242,0V1.809A1.811,1.811,0,0,0,19.03,0H17.842a.621.621,0,0,0,0,1.242" transform="translate(4.162 0)" fill="#fff"/>\n      <path id="Path_1530" data-name="Path 1530" d="M9.562,0H5.4a.621.621,0,0,0,0,1.242H9.562A.621.621,0,0,0,9.562,0" transform="translate(1.156 0)" fill="#fff"/>\n      <path id="Path_1531" data-name="Path 1531" d="M11.623,1.242h4.158a.621.621,0,0,0,0-1.242H11.623a.621.621,0,0,0,0,1.242" transform="translate(2.659 0)" fill="#fff"/>\n      <path id="Path_1532" data-name="Path 1532" d="M3,19.6H1.808a.568.568,0,0,1-.566-.567V17.841a.621.621,0,1,0-1.242,0v1.188a1.81,1.81,0,0,0,1.808,1.809H3A.621.621,0,0,0,3,19.6" transform="translate(0 4.161)" fill="#fff"/>\n      <path id="Path_1533" data-name="Path 1533" d="M9.562,19.134H5.4a.621.621,0,1,0,0,1.242H9.562a.621.621,0,1,0,0-1.242" transform="translate(1.156 4.624)" fill="#fff"/>\n      <path id="Path_1534" data-name="Path 1534" d="M.621,10.183a.621.621,0,0,0,.621-.621V5.4A.621.621,0,0,0,0,5.4V9.562a.621.621,0,0,0,.621.621" transform="translate(0 1.156)" fill="#fff"/>\n      <path id="Path_1535" data-name="Path 1535" d="M.621,16.4a.621.621,0,0,0,.621-.621V11.624a.621.621,0,1,0-1.242,0v4.157a.621.621,0,0,0,.621.621" transform="translate(0 2.659)" fill="#fff"/>\n      <path id="Path_1536" data-name="Path 1536" d="M20.376,5.4a.621.621,0,1,0-1.242,0V9.563a.621.621,0,1,0,1.242,0Z" transform="translate(4.624 1.156)" fill="#fff"/>\n      <path id="Path_1537" data-name="Path 1537" d="M20.217,17.221a.621.621,0,0,0-.621.621V19.03a.568.568,0,0,1-.567.566H17.841a.621.621,0,1,0,0,1.242h1.188a1.811,1.811,0,0,0,1.809-1.808V17.842a.621.621,0,0,0-.621-.621" transform="translate(4.162 4.162)" fill="#fff"/>\n      <path id="Path_1538" data-name="Path 1538" d="M15.781,19.134H11.623a.621.621,0,1,0,0,1.242h4.158a.621.621,0,0,0,0-1.242" transform="translate(2.659 4.624)" fill="#fff"/>\n      <path id="Path_1539" data-name="Path 1539" d="M19.755,11a.621.621,0,0,0-.621.621v4.157a.621.621,0,0,0,1.242,0V11.624A.621.621,0,0,0,19.755,11" transform="translate(4.624 2.659)" fill="#fff"/>\n      <path id="Path_1540" data-name="Path 1540" d="M7.5,18.3a.621.621,0,0,0-.621-.621H4.733l5.149-5.149A.621.621,0,0,0,9,11.656L3.855,16.806V14.579a.621.621,0,0,0-1.242,0V18.3a.611.611,0,0,0,.048.238A.606.606,0,0,0,3,18.877a.606.606,0,0,0,.238.048H6.878A.621.621,0,0,0,7.5,18.3" transform="translate(0.632 2.773)" fill="#fff"/>\n      <path id="Path_1541" data-name="Path 1541" d="M14.173,3.409a.619.619,0,0,0,.621.621h1.836L11.483,9.178a.621.621,0,0,0,.878.878l5.148-5.148V6.744a.621.621,0,1,0,1.242,0V3.41a.606.606,0,0,0-.048-.238.612.612,0,0,0-.335-.335.606.606,0,0,0-.238-.048H14.794a.621.621,0,0,0-.621.621" transform="translate(2.731 0.673)" fill="#fff"/>\n      <path id="Path_1542" data-name="Path 1542" d="M2.661,3.172a.615.615,0,0,0-.048.238V6.744a.621.621,0,0,0,1.242,0V4.908L9,10.057a.621.621,0,0,0,.878-.878L4.733,4.03H6.57a.621.621,0,1,0,0-1.242H3.235A.634.634,0,0,0,3,2.836a.624.624,0,0,0-.335.335" transform="translate(0.632 0.673)" fill="#fff"/>\n      <path id="Path_1543" data-name="Path 1543" d="M18.7,18.545a.617.617,0,0,0,.048-.24h0V14.581a.62.62,0,1,0-1.24,0v2.226l-5.148-5.15a.621.621,0,0,0-.878.878l5.147,5.149H14.4a.621.621,0,0,0-.621.621.623.623,0,0,0,.621.621h3.71a.616.616,0,0,0,.453-.18.6.6,0,0,0,.117-.175c0-.009.012-.016.016-.025" transform="translate(2.731 2.773)" fill="#fff"/>\n    </g>\n  </g>\n</svg>\n\n',autoBounds:'<svg xmlns="http://www.w3.org/2000/svg" width="25.04" height="25" viewBox="0 0 25.04 25">\n  <g id="bounds-detection" transform="translate(0.02)">\n    <g id="Group_306" data-name="Group 306" transform="translate(-0.02)">\n      <path id="Path_982" data-name="Path 982" d="M.791,8.146h.02a.468.468,0,0,0,.516-.416.455.455,0,0,0,0-.063V1.927a1,1,0,0,1,1-1H7.957A.468.468,0,0,0,8.436.492.468.468,0,0,0,7.977.013H2.247A1.913,1.913,0,0,0,.333,1.927v5.74A.468.468,0,0,0,.791,8.146Z" transform="translate(-0.293 -0.012)" fill="#fff"/>\n      <path id="Path_983" data-name="Path 983" d="M140.092,132.044a.468.468,0,0,0-.458-.478h-.02a.468.468,0,0,0-.478.458q0,.01,0,.02v5.74a1,1,0,0,1-1,1h-5.671a.5.5,0,0,0,0,1h5.711a1.913,1.913,0,0,0,1.915-1.912q0-.041,0-.081Z" transform="translate(-115.132 -114.777)" fill="#fff"/>\n      <path id="Path_984" data-name="Path 984" d="M7.665,138.7H1.955a1,1,0,0,1-1-1v-5.661a.468.468,0,0,0-.458-.478H.48a.468.468,0,0,0-.478.458q0,.01,0,.02v5.74A1.914,1.914,0,0,0,1.914,139.7H7.665a.5.5,0,1,0,0-1Z" transform="translate(-0.001 -114.777)" fill="#fff"/>\n      <path id="Path_985" data-name="Path 985" d="M138.405,0l-.081,0h-5.711a.468.468,0,0,0-.478.458q0,.01,0,.02a.468.468,0,0,0,.458.478h5.731a1,1,0,0,1,1,1v5.7a.5.5,0,0,0,1,0V1.915A1.913,1.913,0,0,0,138.405,0Z" transform="translate(-115.277)" fill="#fff"/>\n      <path id="Path_986" data-name="Path 986" d="M32.226,33.132v14.81a1.227,1.227,0,0,0,1.227,1.227H48.265a1.217,1.217,0,0,0,1.227-1.206V33.132a1.217,1.217,0,0,0-1.206-1.227H33.453A1.227,1.227,0,0,0,32.226,33.132Zm16.251-.045a.19.19,0,0,1,0,.045v14.81a.19.19,0,0,1-.179.2H33.453a.19.19,0,0,1-.211-.168.182.182,0,0,1,0-.033V33.132a.19.19,0,0,1,.212-.212H48.265A.191.191,0,0,1,48.477,33.087Z" transform="translate(-28.359 -28.076)" fill="#fff"/>\n      <path id="Path_987" data-name="Path 987" d="M59.363,95.652h9.209a.478.478,0,0,0,.478-.478.488.488,0,0,0-.478-.478H59.363a.488.488,0,0,0-.478.478A.478.478,0,0,0,59.363,95.652Z" transform="translate(-51.309 -82.838)" fill="#fff"/>\n      <path id="Path_988" data-name="Path 988" d="M59.363,128.6h9.209a.478.478,0,0,0,.478-.478.488.488,0,0,0-.478-.478H59.363a.488.488,0,0,0-.478.478A.478.478,0,0,0,59.363,128.6Z" transform="translate(-51.309 -111.663)" fill="#fff"/>\n      <path id="Path_989" data-name="Path 989" d="M59.364,64.6h4.285a.488.488,0,0,0,.478-.478.478.478,0,0,0-.478-.478H59.364a.468.468,0,0,0-.478.458q0,.01,0,.02A.478.478,0,0,0,59.364,64.6Z" transform="translate(-51.443 -55.678)" fill="#fff"/>\n    </g>\n  </g>\n</svg>\n',finish:'<svg id="finish" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n  <defs>\n    <clipPath id="finishclip-path">\n      <rect id="Rectangle_2775" data-name="Rectangle 2775" width="24" height="24" fill="currentColor"/>\n    </clipPath>\n  </defs>\n  <g id="Group_584" data-name="Group 584" clip-path="url(#finishclip-path)">\n    <path id="Path_1526" data-name="Path 1526" d="M17.6,6.7l-6.691,9.081L6.313,12.11a.5.5,0,0,0-.625.781l5,4a.508.508,0,0,0,.378.1.493.493,0,0,0,.337-.2l7-9.5A.5.5,0,1,0,17.6,6.7" fill="currentColor"/>\n    <path id="Path_1527" data-name="Path 1527" d="M12,0A12,12,0,1,0,24,12,12.013,12.013,0,0,0,12,0m0,23A11,11,0,1,1,23,12,11.013,11.013,0,0,1,12,23" fill="currentColor"/>\n  </g>\n</svg>\n',upload:'<svg id="Layer_2" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24">\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="Layer_1-2">\n    <path class="cls-1"\n      d="m17.05,14.93c-.27,0-.48.22-.48.5v5.95l-2.97-6.18c-.1-.21-.32-.32-.54-.26-.22.05-.37.25-.37.49v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-5.95l2.97,6.18c.08.17.25.28.43.28.04,0,.07,0,.11-.01.22-.05.37-.25.37-.49v-8.07c0-.28-.21-.5-.48-.5Z" />\n    <path class="cls-1"\n      d="m8.64,14.93h-1.94c-.27,0-.48.22-.48.5v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-3.53h1.46c1.34,0,2.42-1.13,2.42-2.52s-1.09-2.52-2.42-2.52Zm0,4.03h-1.46v-3.04h1.46c.81,0,1.46.68,1.46,1.52s-.66,1.52-1.46,1.52Z" />\n    <path class="cls-1"\n      d="m23.52,18.62c.27,0,.48-.22.48-.5v-.67c0-1.39-1.09-2.52-2.42-2.52s-2.42,1.13-2.42,2.52v4.03c0,1.39,1.09,2.52,2.42,2.52s2.42-1.13,2.42-2.52v-.67c0-.28-.21-.5-.48-.5h-1.29c-.27,0-.48.22-.48.5s.21.5.48.5h.81v.17c0,.84-.65,1.52-1.46,1.52s-1.46-.68-1.46-1.52v-4.03c0-.84.65-1.52,1.46-1.52s1.46.68,1.46,1.52v.67c0,.28.21.5.48.5Z" />\n    <path class="cls-1"\n      d="m3.65,22.96H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.45c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.6-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.96c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM15.58,1.28c1.86.52,3.31,1.92,3.85,3.71h-3.36c-.27,0-.49-.21-.49-.48V1.28Z" />\n    <path class="cls-1" transform="scale(1, -1) translate(0, -14)"\n      d="m10.32,7.11l-1.65,1.53v-4.58c0-.3-.26-.55-.59-.55s-.59.25-.59.55v4.58l-1.65-1.53c-.23-.21-.6-.21-.84,0s-.23.56,0,.78l2.66,2.47c.05.05.12.09.19.12.07.03.15.04.23.04s.15-.01.23-.04c.07-.03.14-.07.19-.12l2.66-2.47c.23-.21.23-.56,0-.78-.23-.21-.6-.21-.84,0Z" />\n  </g>\n</svg>\n',share:'\n<svg id="sharePng" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24">\n  <defs>\n    <style>\n      .cls-1 {\n        fill: #fff;\n        stroke-width: 0px;\n      }\n    </style>\n  </defs>\n  <g id="sharePng">\n    <path class="cls-1"\n      d="m17.05,14.93c-.27,0-.48.22-.48.5v5.95l-2.97-6.18c-.1-.21-.32-.32-.54-.26-.22.05-.37.25-.37.49v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-5.95l2.97,6.18c.08.17.25.28.43.28.04,0,.07,0,.11-.01.22-.05.37-.25.37-.49v-8.07c0-.28-.21-.5-.48-.5Z" />\n    <path class="cls-1"\n      d="m8.64,14.93h-1.94c-.27,0-.48.22-.48.5v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-3.53h1.46c1.34,0,2.42-1.13,2.42-2.52s-1.09-2.52-2.42-2.52Zm0,4.03h-1.46v-3.04h1.46c.81,0,1.46.68,1.46,1.52s-.66,1.52-1.46,1.52Z" />\n    <path class="cls-1"\n      d="m23.52,18.62c.27,0,.48-.22.48-.5v-.67c0-1.39-1.09-2.52-2.42-2.52s-2.42,1.13-2.42,2.52v4.03c0,1.39,1.09,2.52,2.42,2.52s2.42-1.13,2.42-2.52v-.67c0-.28-.21-.5-.48-.5h-1.29c-.27,0-.48.22-.48.5s.21.5.48.5h.81v.17c0,.84-.65,1.52-1.46,1.52s-1.46-.68-1.46-1.52v-4.03c0-.84.65-1.52,1.46-1.52s1.46.68,1.46,1.52v.67c0,.28.21.5.48.5Z" />\n    <path class="cls-1"\n      d="m3.65,22.96H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.45c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.6-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.96c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM15.58,1.28c1.86.52,3.31,1.92,3.85,3.71h-3.36c-.27,0-.49-.21-.49-.48V1.28Z" />\n    <path transform="scale(0.4, -0.4) translate(8, -30)" stroke="#fff" fill="#fff" stroke-width="1px" d="M19.489,15.009h0c-.008,0-.014,0-.022,0a4.465,4.465,0,0,0-3.749,2.052l-7-3.5a4.482,4.482,0,0,0,0-3.1l7-3.5a4.466,4.466,0,0,0,3.771,2.053l.018,0A4.516,4.516,0,1,0,15.282,6.06L8.257,9.574a4.49,4.49,0,1,0-4.793,6.814,4.548,4.548,0,0,0,1.043.122,4.468,4.468,0,0,0,3.755-2.056l7.018,3.511a4.485,4.485,0,1,0,4.209-2.956M17.13,1.914a3.508,3.508,0,1,1,2.366,6.1h-.01l-.011,0a3.476,3.476,0,0,1-3.112-1.932l0-.006a3.525,3.525,0,0,1,.769-4.162M3.693,15.415a3.5,3.5,0,1,1,3.931-4.967v0a3.47,3.47,0,0,1,0,3.119l0,0a3.479,3.479,0,0,1-3.931,1.842m17.636,7.066a3.5,3.5,0,0,1-4.971-4.53l0,0a3.477,3.477,0,0,1,3.126-1.936l.011,0a3.5,3.5,0,0,1,1.831,6.472" />\n  </g>\n</svg>\n',normalize:'<svg id="normalize" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="19" height="24" viewBox="0 0 19 24">\n<defs>\n  <clipPath id="normalizeclip-path">\n    <rect id="Rectangle_2772" data-name="Rectangle 2772" width="19" height="24" fill="#fff"/>\n  </clipPath>\n</defs>\n<g id="Group_578" data-name="Group 578" clip-path="url(#normalizeclip-path)">\n  <path id="Path_1510" data-name="Path 1510" d="M3.483,18.987a.521.521,0,0,0,.52.522H14.9a.522.522,0,0,0,0-1.044H4a.521.521,0,0,0-.52.522" fill="#fff"/>\n  <path id="Path_1511" data-name="Path 1511" d="M4,13.52h8.75a.522.522,0,0,0,0-1.043H4A.522.522,0,0,0,4,13.52" fill="#fff"/>\n  <path id="Path_1512" data-name="Path 1512" d="M4,10.526h7.448a.522.522,0,0,0,0-1.043H4a.522.522,0,0,0,0,1.043" fill="#fff"/>\n  <path id="Path_1513" data-name="Path 1513" d="M4,7.532H9.927a.522.522,0,0,0,0-1.043H4A.522.522,0,0,0,4,7.532" fill="#fff"/>\n  <path id="Path_1514" data-name="Path 1514" d="M4.005,15.471H4a.522.522,0,0,0,0,1.043l9.79.039h0a.522.522,0,0,0,0-1.043Z" fill="#fff"/>\n  <path id="Path_1515" data-name="Path 1515" d="M9.33,1.044H11.5A.522.522,0,0,0,11.5,0H9.33a.522.522,0,0,0,0,1.043" fill="#fff"/>\n  <path id="Path_1516" data-name="Path 1516" d="M13.679,1.044h2.174a.522.522,0,0,0,0-1.043H13.679a.522.522,0,0,0,0,1.043" fill="#fff"/>\n  <path id="Path_1517" data-name="Path 1517" d="M18.48,17.548a.516.516,0,0,0-.367.152c-.572-3.035-1.506-7.61-3.012-14.546a.524.524,0,0,0-.139-.256,1.432,1.432,0,0,0-.972-.437L6.806,1.044h.349A.522.522,0,0,0,7.155,0H4.981A.522.522,0,0,0,4.46.522a.426.426,0,0,0,.013.062L3.291.351A.516.516,0,0,0,2.805,0H1.765a.515.515,0,0,0-.124.025L1.515,0A1.52,1.52,0,0,0,0,1.52V22.481A1.519,1.519,0,0,0,1.515,24H18.432a.142.142,0,0,0,.022,0,.238.238,0,0,0,.026,0,.52.52,0,0,0,.52-.521V22.435a.522.522,0,0,0-.152-.369c-.047-.358-.111-.8-.2-1.329A.516.516,0,0,0,19,20.25V18.069a.519.519,0,0,0-.52-.521M1.515,22.957a.475.475,0,0,1-.474-.476V1.52a.491.491,0,0,1,.373-.486L13.89,3.495a.468.468,0,0,1,.233.061c1.449,6.682,3.613,17.143,3.823,19.4Z" fill="#fff"/>\n  <path id="Path_1518" data-name="Path 1518" d="M18.48,4.461a.52.52,0,0,0-.52.522v2.18a.52.52,0,1,0,1.04,0V4.983a.52.52,0,0,0-.52-.522" fill="#fff"/>\n  <path id="Path_1519" data-name="Path 1519" d="M18.29.366a.521.521,0,0,0-.638.824.827.827,0,0,1,.308.653V2.8A.52.52,0,1,0,19,2.8V1.843A1.877,1.877,0,0,0,18.29.366" fill="#fff"/>\n  <path id="Path_1520" data-name="Path 1520" d="M18.48,13.185a.52.52,0,0,0-.52.522v2.181a.52.52,0,1,0,1.04,0V13.707a.52.52,0,0,0-.52-.522" fill="#fff"/>\n  <path id="Path_1521" data-name="Path 1521" d="M18.48,8.823a.52.52,0,0,0-.52.522v2.181a.52.52,0,1,0,1.04,0V9.345a.52.52,0,0,0-.52-.522" fill="#fff"/>\n</g>\n</svg>\n',retake:'<svg id="re-take" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="28.761" height="23" viewBox="0 0 28.761 23">\n<defs>\n<clipPath id="retakeclip-path">\n  <rect id="Rectangle_2773" data-name="Rectangle 2773" width="28.761" height="23" fill="#fff"/>\n</clipPath>\n</defs>\n<g id="Group_580" data-name="Group 580" clip-path="url(#retakeclip-path)">\n<path id="Path_1522" data-name="Path 1522" d="M25.877,3.639H21.663a.7.7,0,0,1-.575-.288l-.575-.764C19.264.961,18.59,0,17.44,0H11.4C10.151,0,9.486.961,8.336,2.588l-.674.764a.7.7,0,0,1-.575.288H2.875C.476,3.639,0,5.077,0,6.227v13.9C0,22.041,1.051,23,2.974,23H25.787c1.914,0,2.974-.961,2.974-2.776v-14c-.008-1.147-.485-2.585-2.884-2.585m-.1,18.411H2.974c-1.339,0-2.013-.575-2.013-1.824v-14c0-.863.189-1.626,1.914-1.626H7.188a1.666,1.666,0,0,0,1.339-.674L9.1,3.162c1.15-1.626,1.536-2.2,2.2-2.2H17.34c.674,0,1.15.575,2.3,2.2l.575.764a1.562,1.562,0,0,0,1.339.674h4.313c1.725,0,1.914.764,1.914,1.626v14h.009c0,1.249-.673,1.824-2.012,1.824" fill="#fff"/>\n<path id="Path_1523" data-name="Path 1523" d="M15.978,9.16H9.462l1.745-1.743A.5.5,0,0,0,10.5,6.71l-2.6,2.6a.484.484,0,0,0-.108.162.5.5,0,0,0,0,.382.479.479,0,0,0,.108.163l2.6,2.6a.5.5,0,0,0,.708-.708L9.462,10.16h6.516a4.028,4.028,0,0,1,0,8.055H10.255a.5.5,0,1,0,0,1h5.723a5.028,5.028,0,0,0,0-10.055" fill="#fff"/>\n</g>\n</svg>\n',complete:'\n<svg id="continue" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="24" height="24" viewBox="0 0 24 24">\n<defs>\n<clipPath id="continueclip-path">\n  <rect id="Rectangle_2774" data-name="Rectangle 2774" width="24" height="24" fill="currentColor"/>\n</clipPath>\n</defs>\n<g id="Group_582" data-name="Group 582" clip-path="url(#continueclip-path)">\n<path id="Path_1524" data-name="Path 1524" d="M12,0A12,12,0,1,0,24,12,12.013,12.013,0,0,0,12,0m0,23A11,11,0,1,1,23,12,11.013,11.013,0,0,1,12,23" fill="currentColor"/>\n<path id="Path_1525" data-name="Path 1525" d="M19.862,12a.17.17,0,0,0,0-.024.512.512,0,0,0-.033-.168.532.532,0,0,0-.113-.17l-4.219-4.29a.5.5,0,0,0-.714,0,.51.51,0,0,0,0,.719l3.371,3.428H4.643a.509.509,0,0,0,0,1.018h13.5l-3.373,3.428a.512.512,0,0,0,0,.72.5.5,0,0,0,.714,0l4.224-4.295a.438.438,0,0,0,.056-.086.5.5,0,0,0,.051-.078A.521.521,0,0,0,19.862,12h0" fill="currentColor"/>\n</g>\n</svg>\n',downloadPNG:'\n<svg id="Layer_2" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" width="24" height="24">\n<defs>\n<style>\n  .cls-1 {\n    fill: #fff;\n    stroke-width: 0px;\n  }\n</style>\n</defs>\n<g id="Layer_1-2">\n<path class="cls-1"\n  d="m17.05,14.93c-.27,0-.48.22-.48.5v5.95l-2.97-6.18c-.1-.21-.32-.32-.54-.26-.22.05-.37.25-.37.49v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-5.95l2.97,6.18c.08.17.25.28.43.28.04,0,.07,0,.11-.01.22-.05.37-.25.37-.49v-8.07c0-.28-.21-.5-.48-.5Z" />\n<path class="cls-1"\n  d="m8.64,14.93h-1.94c-.27,0-.48.22-.48.5v8.07c0,.28.21.5.48.5s.48-.22.48-.5v-3.53h1.46c1.34,0,2.42-1.13,2.42-2.52s-1.09-2.52-2.42-2.52Zm0,4.03h-1.46v-3.04h1.46c.81,0,1.46.68,1.46,1.52s-.66,1.52-1.46,1.52Z" />\n<path class="cls-1"\n  d="m23.52,18.62c.27,0,.48-.22.48-.5v-.67c0-1.39-1.09-2.52-2.42-2.52s-2.42,1.13-2.42,2.52v4.03c0,1.39,1.09,2.52,2.42,2.52s2.42-1.13,2.42-2.52v-.67c0-.28-.21-.5-.48-.5h-1.29c-.27,0-.48.22-.48.5s.21.5.48.5h.81v.17c0,.84-.65,1.52-1.46,1.52s-1.46-.68-1.46-1.52v-4.03c0-.84.65-1.52,1.46-1.52s1.46.68,1.46,1.52v.67c0,.28.21.5.48.5Z" />\n<path class="cls-1"\n  d="m3.65,22.96H1.58c-.27,0-.49-.21-.49-.48V1.52c0-.26.22-.48.49-.48h12.45c.16,0,.31.03.47.05v3.42c0,.84.71,1.52,1.58,1.52h3.55c.01.15.05.3.05.45v6.01c0,.29.24.52.54.52s.54-.23.54-.52v-6.01c0-.33-.03-.65-.08-.97,0,0,0,0,0,0,0,0,0-.02,0-.02-.45-2.77-2.72-4.97-5.6-5.4-.01,0-.02,0-.03,0,0,0,0,0,0,0-.33-.05-.66-.08-1-.08H1.58C.71,0,0,.68,0,1.52v20.96c0,.84.71,1.52,1.58,1.52h2.07c.3,0,.54-.23.54-.52s-.24-.52-.54-.52ZM15.58,1.28c1.86.52,3.31,1.92,3.85,3.71h-3.36c-.27,0-.49-.21-.49-.48V1.28Z" />\n<path class="cls-1"\n  d="m10.32,7.11l-1.65,1.53v-4.58c0-.3-.26-.55-.59-.55s-.59.25-.59.55v4.58l-1.65-1.53c-.23-.21-.6-.21-.84,0s-.23.56,0,.78l2.66,2.47c.05.05.12.09.19.12.07.03.15.04.23.04s.15-.01.23-.04c.07-.03.14-.07.19-.12l2.66-2.47c.23-.21.23-.56,0-.78-.23-.21-.6-.21-.84,0Z" />\n</g>\n</svg>\n'};class D{constructor(e,t,i){var n,a;this.resources=e,this.config=t,this.scannerView=i,this.imageEditorView=null,this.layer=null,this.config.utilizedTemplateNames={detect:(null===(n=t.utilizedTemplateNames)||void 0===n?void 0:n.detect)||f,normalize:(null===(a=t.utilizedTemplateNames)||void 0===a?void 0:a.normalize)||p}}async initialize(){if(!this.resources.result)throw Error("Captured image is missing. Please capture an image first!");if(!this.config.container)throw new Error("Please create an Correction View Container element");E("dds-correction-view-style",I);const e=document.createElement("div");e.className="dds-correction-view-container";const t=document.createElement("div");if(Object.assign(t.style,{width:"100%",height:"100%"}),e.appendChild(t),C(this.config.container).appendChild(e),this.imageEditorView=await a.ImageEditorView.createInstance(t),this.layer=this.imageEditorView.createDrawingLayer(),this.imageEditorView.setOriginalImage(this.resources.result.originalImageResult),this.setupDrawingLayerStyle(),this.setupInitialDetectedQuad(),this.setupCorrectionControls(),this.setupQuadConstraints(),this.resources.result._flowType===w.STATIC_FILE){document.querySelector("#dds-correction-retake").style.display="none"}}setupDrawingLayerStyle(){const e=a.DrawingStyleManager.createDrawingStyle({lineWidth:5,fillStyle:"transparent",strokeStyle:"#FE8E14",paintMode:"stroke"});this.layer.setDefaultStyle(e)}setupQuadConstraints(){const e=this.layer.fabricCanvas;e.defaultCursor="default",e.hoverCursor="default",e.moveCursor="default",e.on("object:scaling",(t=>{const i=t.target,n=i.points,a=this.getCanvasBounds();n.forEach((e=>{e.x=Math.max(0,Math.min(a.width,e.x)),e.y=Math.max(0,Math.min(a.height,e.y))})),i.set({points:n,dirty:!0}),e.renderAll()})),e.on("object:modified",(t=>{const i=t.target;if(!i)return;const n=i.points,a=this.getCanvasBounds();let s=!1;n.forEach((e=>{(e.x<0||e.x>a.width||e.y<0||e.y>a.height)&&(s=!0)})),s&&(n.forEach((e=>{e.x=Math.max(0,Math.min(a.width,e.x)),e.y=Math.max(0,Math.min(a.height,e.y))})),i.set({points:n,dirty:!0}),e.renderAll())}))}getCanvasBounds(){const e=this.layer.fabricCanvas;return{width:e.getWidth(),height:e.getHeight()}}addQuadToLayer(e){var t,i;this.layer.clearDrawingItems();const n=e._getFabricObject(),a=.1*Math.min(null===(t=this.resources.result.originalImageResult)||void 0===t?void 0:t.width,null===(i=this.resources.result.originalImageResult)||void 0===i?void 0:i.height);n.cornerSize=a,n.lockMovementX=!0,n.lockMovementY=!0,n.on("mousedown",(function(e){var t;e.target&&e.target.controls&&(this.cornerColor="transparent",this.dirty=!0,null===(t=this.canvas)||void 0===t||t.renderAll())})),n.on("mouseup",(function(){var e;this.cornerColor="#FE8E14",this.dirty=!0,null===(e=this.canvas)||void 0===e||e.renderAll()})),this.layer.renderAll(),this.layer.addDrawingItems([e]),this.layer.fabricCanvas.setActiveObject(n),this.layer.fabricCanvas.renderAll()}setupInitialDetectedQuad(){let e;if(this.resources.result.detectedQuadrilateral)e=new a.QuadDrawingItem(this.resources.result.detectedQuadrilateral);else{const{width:t,height:i}=this.resources.result.originalImageResult;e=new a.QuadDrawingItem({points:[{x:0,y:0},{x:t,y:0},{x:t,y:i},{x:0,y:i}],area:t*i})}this.addQuadToLayer(e)}createControls(){var e,t,i,n,a,s,o,r,l,c,d,h,u,m,g,f,p,v;const{toolbarButtonsConfig:w}=this.config;return y([{id:"dds-correction-retake",icon:(null===(e=null==w?void 0:w.retake)||void 0===e?void 0:e.icon)||b.retake,label:(null===(t=null==w?void 0:w.retake)||void 0===t?void 0:t.label)||"Re-take",onClick:()=>this.handleRetake(),className:`${(null===(i=null==w?void 0:w.retake)||void 0===i?void 0:i.className)||""}`,isHidden:(null===(n=null==w?void 0:w.retake)||void 0===n?void 0:n.isHidden)||!1,isDisabled:!this.scannerView},{id:"dds-correction-fullImage",icon:(null===(a=null==w?void 0:w.fullImage)||void 0===a?void 0:a.icon)||b.fullImage,label:(null===(s=null==w?void 0:w.fullImage)||void 0===s?void 0:s.label)||"Full Image",className:`${(null===(o=null==w?void 0:w.fullImage)||void 0===o?void 0:o.className)||""}`,isHidden:(null===(r=null==w?void 0:w.fullImage)||void 0===r?void 0:r.isHidden)||!1,onClick:()=>this.setFullImageBoundary()},{id:"dds-correction-detectBorders",icon:(null===(l=null==w?void 0:w.detectBorders)||void 0===l?void 0:l.icon)||b.autoBounds,label:(null===(c=null==w?void 0:w.detectBorders)||void 0===c?void 0:c.label)||"Detect Borders",className:`${(null===(d=null==w?void 0:w.detectBorders)||void 0===d?void 0:d.className)||""}`,isHidden:(null===(h=null==w?void 0:w.detectBorders)||void 0===h?void 0:h.isHidden)||!1,onClick:()=>this.setBoundaryAutomatically()},{id:"dds-correction-apply",icon:(null===(u=null==w?void 0:w.apply)||void 0===u?void 0:u.icon)||(!1===(null===(m=this.config)||void 0===m?void 0:m._showResultView)?b.complete:b.finish),label:(null===(g=null==w?void 0:w.apply)||void 0===g?void 0:g.label)||(!1===(null===(f=this.config)||void 0===f?void 0:f._showResultView)?"Done":"Apply"),className:`${(null===(p=null==w?void 0:w.apply)||void 0===p?void 0:p.className)||""}`,isHidden:(null===(v=null==w?void 0:w.apply)||void 0===v?void 0:v.isHidden)||!1,onClick:()=>this.confirmCorrection()}])}setupCorrectionControls(){try{const e=this.createControls(),t=C(this.config.container).firstElementChild;t&&t.appendChild(e)}catch(e){throw console.error("Error setting up correction controls:",e),new Error(`Failed to setup correction controls: ${e.message}`)}}async handleRetake(){var t;try{if(!this.scannerView)return void console.error("Correction View not initialized");this.hideView();const i=await this.scannerView.launch();if((null===(t=null==i?void 0:i.status)||void 0===t?void 0:t.code)===e.EnumResultStatus.RS_FAILED)return void(this.currentCorrectionResolver&&this.currentCorrectionResolver(i));this.resources.onResultUpdated&&((null==i?void 0:i.status.code)===e.EnumResultStatus.RS_CANCELLED?this.resources.onResultUpdated(this.resources.result):(null==i?void 0:i.status.code)===e.EnumResultStatus.RS_SUCCESS&&this.resources.onResultUpdated(i)),this.dispose(!0),await this.initialize(),C(this.config.container).style.display="flex"}catch(t){throw console.error("Error in retake handler:",t),this.currentCorrectionResolver&&this.currentCorrectionResolver({status:{code:e.EnumResultStatus.RS_FAILED,message:(null==t?void 0:t.message)||t}}),t}}setFullImageBoundary(){if(!this.resources.result)throw Error("Captured image is missing. Please capture an image first!");const{width:e,height:t}=this.resources.result.originalImageResult,i=new a.QuadDrawingItem({points:[{x:0,y:0},{x:e,y:0},{x:e,y:t},{x:0,y:t}],area:e*t});this.addQuadToLayer(i)}async setBoundaryAutomatically(){var e;this.config.templateFilePath&&await this.resources.cvRouter.initSettings(this.config.templateFilePath);let i=await this.resources.cvRouter.getSimplifiedSettings(this.config.utilizedTemplateNames.detect);i.capturedResultItemTypes|=t.EnumCapturedResultItemType.CRIT_ORIGINAL_IMAGE,await this.resources.cvRouter.updateSettings(this.config.utilizedTemplateNames.detect,i),this.resources.cvRouter.maxImageSideLength=1/0;const n=null===(e=(await this.resources.cvRouter.capture(this.resources.result.originalImageResult,"DetectDocumentBoundaries_Default")).items.find((e=>e.type===t.EnumCapturedResultItemType.CRIT_DETECTED_QUAD)))||void 0===e?void 0:e.location;n?this.addQuadToLayer(new a.QuadDrawingItem(n)):this.setFullImageBoundary()}async confirmCorrection(){var e;const t=this.layer.getDrawingItems()[0];if(!t)throw new Error("No quad drawing item found");const i=t.getQuad(),n=await this.correctImage(null==i?void 0:i.points);if(n){const t=Object.assign(Object.assign({},this.resources.result),{correctedImageResult:n,detectedQuadrilateral:i});this.resources.onResultUpdated&&this.resources.onResultUpdated(t),(null===(e=this.config)||void 0===e?void 0:e.onFinish)&&this.config.onFinish(t),this.currentCorrectionResolver&&this.currentCorrectionResolver(t)}else this.currentCorrectionResolver&&this.currentCorrectionResolver(this.resources.result);this.dispose(),this.hideView()}async launch(){var t,i;try{return(null===(t=this.resources.result)||void 0===t?void 0:t.correctedImageResult)?(C(this.config.container).textContent="",await this.initialize(),C(this.config.container).style.display="flex",new Promise((e=>{this.currentCorrectionResolver=e}))):{status:{code:e.EnumResultStatus.RS_FAILED,message:"No image available for correction"}}}catch(t){let n=(null==t?void 0:t.message)||t;if(console.error(n),!(null===(i=this.resources.result)||void 0===i?void 0:i.correctedImageResult))return{status:{code:e.EnumResultStatus.RS_FAILED,message:n}}}}hideView(){C(this.config.container).style.display="none"}async correctImage(e){var t;const{cvRouter:i}=this.resources;this.config.templateFilePath&&await this.resources.cvRouter.initSettings(this.config.templateFilePath);const n=await i.getSimplifiedSettings(this.config.utilizedTemplateNames.normalize);n.roiMeasuredInPercentage=!1,n.roi.points=e,await i.updateSettings(this.config.utilizedTemplateNames.normalize,n);const a=await i.capture(this.resources.result.originalImageResult,this.config.utilizedTemplateNames.normalize);if(null===(t=null==a?void 0:a.normalizedImageResultItems)||void 0===t?void 0:t[0])return a.normalizedImageResultItems[0]}dispose(e=!1){var t,i;(null===(t=this.imageEditorView)||void 0===t?void 0:t.dispose)&&this.imageEditorView.dispose(),this.layer=null,(null===(i=this.config)||void 0===i?void 0:i.container)&&(C(this.config.container).textContent=""),e||(this.currentCorrectionResolver=void 0)}}const I="\n  .dds-correction-view-container {\n    display: flex;\n    width: 100%;\n    height: 100%;\n    background-color:#575757;\n    font-size: 12px;\n    flex-direction: column;\n    align-items: center;\n  }\n\n  @media (orientation: landscape) and (max-width: 1024px) {\n    .dds-correction-view-container {\n      flex-direction: row;\n    }\n  }\n";function P(e,t={}){const{message:i,spinnerSize:n=32}=t,a=document.createElement("div");a.className="dds-loading-screen";const s=document.createElement("div");s.className="dds-loading";const o=document.createElement("div");o.className="dds-loading-content";const r=`\n    <svg \n      xmlns="http://www.w3.org/2000/svg" \n      viewBox="0 0 24 24" \n      fill="none" \n      stroke="white" \n      stroke-linecap="round" \n      stroke-linejoin="round" \n      width="${n}" \n      height="${n}" \n      stroke-width="0.75"\n    > \n      <path d="M12 3a9 9 0 1 0 9 9"></path> \n    </svg>\n  `;if(o.innerHTML=r,i){const e=document.createElement("div");e.className="dds-loading-message",e.textContent=i,o.appendChild(e)}return s.appendChild(o),a.appendChild(s),e.appendChild(a),{element:a,updateMessage:e=>{let t=s.querySelector(".dds-loading-message");null!==e?t?t.textContent=e:(t=document.createElement("div"),t.className="dds-loading-message",t.textContent=e,o.appendChild(t)):null==t||t.remove()},hide:()=>{a&&a.parentNode&&(a.classList.add("fade-out"),setTimeout((()=>{var e;null===(e=a.parentNode)||void 0===e||e.removeChild(a)}),200))}}}class A{showScannerLoadingOverlay(e){const t=C(this.config.container);this.loadingScreen=P(t,{message:e}),t.style.display="block",t.style.position="relative"}hideScannerLoadingOverlay(e=!1){this.loadingScreen&&(this.loadingScreen.hide(),this.loadingScreen=null,e&&(C(this.config.container).style.display="none"))}getMinVerifiedFramesForAutoCapture(){var e,t,i,n;return!(null===(e=this.config)||void 0===e?void 0:e.minVerifiedFramesForAutoCapture)||(null===(t=this.config)||void 0===t?void 0:t.minVerifiedFramesForAutoCapture)<=0||(null===(i=this.config)||void 0===i?void 0:i.minVerifiedFramesForAutoCapture)>5?2:null===(n=this.config)||void 0===n?void 0:n.minVerifiedFramesForAutoCapture}constructor(e,t){var i,n;this.resources=e,this.config=t,this.boundsDetectionEnabled=!1,this.smartCaptureEnabled=!1,this.autoCropEnabled=!1,this.resizeTimer=null,this.capturedResultItems=[],this.originalImageData=null,this.initialized=!1,this.initializedDCE=!1,this.DCE_ELEMENTS={selectCameraBtn:null,uploadImageBtn:null,closeScannerBtn:null,takePhotoBtn:null,boundsDetectionBtn:null,smartCaptureBtn:null,autoCropBtn:null},this.loadingScreen=null,this.handleResize=()=>{this.toggleScanGuide(!1),this.resizeTimer&&window.clearTimeout(this.resizeTimer),this.resizeTimer=window.setTimeout((()=>{this.toggleScanGuide(!0)}),500)},this.config.utilizedTemplateNames={detect:(null===(i=t.utilizedTemplateNames)||void 0===i?void 0:i.detect)||f,normalize:(null===(n=t.utilizedTemplateNames)||void 0===n?void 0:n.normalize)||p}}async initialize(){var i,a,s,r,l,c,d,h,u,m,g,f,p;if(this.autoCropEnabled=null!==(a=null===(i=this.config)||void 0===i?void 0:i.enableAutoCropMode)&&void 0!==a&&a,this.smartCaptureEnabled=null!==(l=(null===(s=this.config)||void 0===s?void 0:s.enableSmartCaptureMode)||(null===(r=this.config)||void 0===r?void 0:r.enableAutoCropMode))&&void 0!==l&&l,this.boundsDetectionEnabled=!0,this.config.minVerifiedFramesForAutoCapture=this.getMinVerifiedFramesForAutoCapture(),!this.initialized){E("dds-loading-screen-style",'\n  .dds-loading-screen {\n    position: absolute;\n    top: 0;\n    left: 0;\n    right: 0;\n    bottom: 0;\n    background-color: #323234;\n    z-index: 998;\n    opacity: 1;\n    transition: opacity 0.2s ease-out;\n  }\n\n  .dds-loading-screen.fade-out {\n    opacity: 0;\n  }\n\n  .dds-loading {\n    position: absolute;\n    left: 50%;\n    top: 50%;\n    color: white;\n    z-index: 999;\n    transform: translate(-50%, -50%);\n  }\n\n  .dds-loading-content {\n    display: flex;\n    flex-direction: column;\n    align-items: center;\n    gap: 16px;\n  }\n\n  .dds-loading svg {\n    animation: spin 1s linear infinite;\n  }\n\n  .dds-loading-message {\n    color: white;\n    font-family: "Verdana";\n    font-size: 14px;\n    text-align: center;\n    max-width: 200px;\n    line-height: 1.4;\n    opacity: 0.9;\n  }\n\n  @keyframes spin {\n    from {\n      transform: rotate(0deg);\n    }\n    to {\n      transform: rotate(360deg);\n    }\n  }\n');try{const{cameraView:e,cameraEnhancer:i,cvRouter:a}=this.resources;e.setScanRegionMaskStyle(Object.assign(Object.assign({},e.getScanRegionMaskStyle()),{lineWidth:null!==(u=null===(h=null===(d=null===(c=this.config)||void 0===c?void 0:c.scanRegion)||void 0===d?void 0:d.style)||void 0===h?void 0:h.strokeWidth)&&void 0!==u?u:2,strokeStyle:null!==(p=null===(f=null===(g=null===(m=this.config)||void 0===m?void 0:m.scanRegion)||void 0===g?void 0:g.style)||void 0===f?void 0:f.strokeColor)&&void 0!==p?p:"transparent"})),e.setVideoFit("cover"),a.setInput(i);const s=new o.MultiFrameResultCrossFilter;s.enableResultCrossVerification(t.EnumCapturedResultItemType.CRIT_DETECTED_QUAD,!0),s.enableResultDeduplication(t.EnumCapturedResultItemType.CRIT_DETECTED_QUAD,!0),await a.addResultFilter(s),this.config.templateFilePath&&await a.initSettings(this.config.templateFilePath);let r=await a.getSimplifiedSettings(this.config.utilizedTemplateNames.detect);r.capturedResultItemTypes|=t.EnumCapturedResultItemType.CRIT_ORIGINAL_IMAGE,r.documentSettings.scaleDownThreshold=1e3,await a.updateSettings(this.config.utilizedTemplateNames.detect,r),a.maxImageSideLength=1/0;const l=new n.CapturedResultReceiver;l.onCapturedResultReceived=e=>this.handleBoundsDetection(e),await a.addResultReceiver(l),this.initialized=!0}catch(t){let i=(null==t?void 0:t.message)||t;console.error(i),alert(i),this.closeCamera();const n={status:{code:e.EnumResultStatus.RS_FAILED,message:"DDS Init error"}};this.currentScanResolver(n)}}}async initializeElements(){var e,t;const i=C(this.config.container),n=i.children[i.children.length-1];if(!(null==n?void 0:n.shadowRoot))throw new Error("Shadow root not found");if(this.DCE_ELEMENTS={selectCameraBtn:n.shadowRoot.querySelector(".dce-mn-select-camera-icon"),uploadImageBtn:n.shadowRoot.querySelector(".dce-mn-upload-image-icon"),closeScannerBtn:n.shadowRoot.querySelector(".dce-mn-close"),takePhotoBtn:n.shadowRoot.querySelector(".dce-mn-take-photo"),boundsDetectionBtn:n.shadowRoot.querySelector(".dce-mn-bounds-detection"),smartCaptureBtn:n.shadowRoot.querySelector(".dce-mn-smart-capture"),autoCropBtn:n.shadowRoot.querySelector(".dce-mn-auto-crop")},this.assignDCEClickEvents(),!1===this.config._showCorrectionView&&(this.DCE_ELEMENTS.smartCaptureBtn.style.display="none"),!1===(null===(e=this.config)||void 0===e?void 0:e.showSubfooter)){n.shadowRoot.querySelector(".dce-subfooter").style.display="none"}if(!1===(null===(t=this.config)||void 0===t?void 0:t.showPoweredByDynamsoft)){n.shadowRoot.querySelector(".dce-mn-msg-poweredby").style.display="none"}this.initializedDCE=!0}assignDCEClickEvents(){if(!Object.values(this.DCE_ELEMENTS).every(Boolean))throw new Error("Camera control elements not found");this.takePhoto=this.takePhoto.bind(this),this.toggleBoundsDetection=this.toggleBoundsDetection.bind(this),this.toggleSmartCapture=this.toggleSmartCapture.bind(this),this.toggleAutoCrop=this.toggleAutoCrop.bind(this),this.closeCamera=this.closeCamera.bind(this),this.DCE_ELEMENTS.takePhotoBtn.onclick=this.takePhoto,this.DCE_ELEMENTS.boundsDetectionBtn.onclick=async()=>{await this.toggleBoundsDetection()},this.DCE_ELEMENTS.smartCaptureBtn.onclick=async()=>{await this.toggleSmartCapture()},this.DCE_ELEMENTS.autoCropBtn.onclick=async()=>{await this.toggleAutoCrop()},this.DCE_ELEMENTS.closeScannerBtn.onclick=async()=>{await this.handleCloseBtn()},this.DCE_ELEMENTS.selectCameraBtn.onclick=e=>{e.stopPropagation(),this.toggleSelectCameraBox()},this.DCE_ELEMENTS.uploadImageBtn.onclick=()=>{this.uploadImage()}}async handleCloseBtn(){this.closeCamera(),this.currentScanResolver&&this.currentScanResolver({status:{code:e.EnumResultStatus.RS_CANCELLED,message:"Cancelled"}})}attachOptionClickListeners(){const e=C(this.config.container),t=e.children[e.children.length-1];if(!(null==t?void 0:t.shadowRoot))return;const i=t.shadowRoot.querySelector(".dce-mn-camera-and-resolution-settings");[...t.shadowRoot.querySelectorAll(".dce-mn-camera-option"),...t.shadowRoot.querySelectorAll(".dce-mn-resolution-option")].forEach((e=>{e.onclick=()=>{const t=e.getAttribute("data-davice-id"),n=e.getAttribute("data-height"),a=e.getAttribute("data-width");t?this.resources.cameraEnhancer.selectCamera(t).then((()=>{this.toggleScanGuide(!0)})):n&&a&&this.resources.cameraEnhancer.setResolution({width:parseInt(a),height:parseInt(n)}).then((()=>{this.toggleScanGuide(!0)})),"none"!==i.style.display&&this.toggleSelectCameraBox()}}))}highlightCameraAndResolutionOption(){const e=C(this.config.container),t=e.children[e.children.length-1];if(!(null==t?void 0:t.shadowRoot))return;const i=t.shadowRoot.querySelector(".dce-mn-camera-and-resolution-settings"),n=i.querySelectorAll(".dce-mn-camera-option"),a=i.querySelectorAll(".dce-mn-resolution-option"),s=this.resources.cameraEnhancer.getSelectedCamera(),o=this.resources.cameraEnhancer.getResolution();n.forEach((e=>{const t=e;t.getAttribute("data-davice-id")===(null==s?void 0:s.deviceId)?t.style.border="2px solid #fe814a":t.style.border="none"}));const r={"480p":"480","720p":"720","1080p":"1080","2k":"1440","4k":"2160"},l=function(e){const t=e.width*e.height,i=e.width/e.height;let n="480p",a=Number.MAX_VALUE;for(const[e,s]of Object.entries(V)){const o=s.width*s.height,r=s.width/s.height,l=.7*Math.abs(o-t)+Math.abs(r-i)*o*.3;l<a&&(a=l,n=e)}return n}(o);a.forEach((e=>{const t=e,i=t.getAttribute("data-height");t.style.border=i===r[l]?"2px solid #fe814a":"none"}))}toggleSelectCameraBox(){const e=C(this.config.container),t=e.children[e.children.length-1];if(!(null==t?void 0:t.shadowRoot))return;const i=t.shadowRoot.querySelector(".dce-mn-resolution-box");this.highlightCameraAndResolutionOption(),this.attachOptionClickListeners(),i.click(),this.toggleScanGuide(!0)}async uploadImage(){var i,n,a,s,o;const r=document.createElement("input");r.type="file",r.accept="image/png,image/jpeg",r.style.display="none",document.body.appendChild(r);try{this.showScannerLoadingOverlay("Processing image...");const l=await new Promise(((e,t)=>{r.onchange=i=>{var n;const a=null===(n=i.target.files)||void 0===n?void 0:n[0];(null==a?void 0:a.type.startsWith("image/"))?e(a):t(new Error("Please select an image file"))},r.addEventListener("cancel",(()=>this.hideScannerLoadingOverlay(!1))),r.click()}));if(!l)return void this.hideScannerLoadingOverlay(!1);this.closeCamera(!1);const{blob:c}=await this.fileToBlob(l);this.capturedResultItems=(await this.resources.cvRouter.capture(c,this.config.utilizedTemplateNames.detect)).items,this.originalImageData=null===(i=this.capturedResultItems[0])||void 0===i?void 0:i.imageData;let d=null;if((null===(n=this.capturedResultItems)||void 0===n?void 0:n.length)<=1){this.capturedResultItems=[];const{width:e,height:t}=this.originalImageData;d={points:[{x:0,y:0},{x:e,y:0},{x:e,y:t},{x:0,y:t}],area:t*e}}else d=null===(a=this.capturedResultItems.find((e=>e.type===t.EnumCapturedResultItemType.CRIT_DETECTED_QUAD)))||void 0===a?void 0:a.location;const h=await this.normalizeImage(d.points,this.originalImageData),u={status:{code:e.EnumResultStatus.RS_SUCCESS,message:"Success"},originalImageResult:this.originalImageData,correctedImageResult:h,detectedQuadrilateral:d,_flowType:w.UPLOADED_IMAGE};null===(o=(s=this.resources).onResultUpdated)||void 0===o||o.call(s,u),this.currentScanResolver(u),this.hideScannerLoadingOverlay(!0)}catch(t){let i=(null==t?void 0:t.message)||t;console.error(i),alert(i),this.closeCamera();const n={status:{code:e.EnumResultStatus.RS_FAILED,message:"Error processing uploaded image"}};this.currentScanResolver(n)}finally{document.body.removeChild(r)}}async fileToBlob(e){return new Promise(((t,i)=>{const n=new Image;n.onload=()=>{const a=document.createElement("canvas");a.width=n.width,a.height=n.height;const s=a.getContext("2d");null==s||s.drawImage(n,0,0),a.toBlob((e=>{e?t({blob:e,width:n.width,height:n.height}):i(new Error("Failed to create blob"))}),e.type)},n.onerror=i,n.src=URL.createObjectURL(e)}))}async toggleAutoCaptureAnimation(e){const t=C(this.config.container),i=t.children[t.children.length-1];if(!(null==i?void 0:i.shadowRoot))return;const n=i.shadowRoot.querySelector(".dce-loading-auto-capture-animation");n.style.borderLeftColor=e?"transparent":"#fe8e14",n.style.borderBottomColor=e?"transparent":"#fe8e14"}async toggleBoundsDetection(e){const t=C(this.config.container),i=t.children[t.children.length-1];if(!(null==i?void 0:i.shadowRoot))return;const n=i.shadowRoot.querySelector(".dce-mn-bounds-detection"),a=i.shadowRoot.querySelector(".dce-mn-bounds-detection-on"),s=i.shadowRoot.querySelector(".dce-mn-bounds-detection-off");if(!a||!s)return;this.toggleAutoCaptureAnimation(!1);const o=void 0!==e?e:!this.boundsDetectionEnabled;o||await this.toggleSmartCapture(!1);const{cvRouter:r}=this.resources;this.boundsDetectionEnabled=o,n.style.color=this.boundsDetectionEnabled?"#fe814a":"#fff",s.style.display=this.boundsDetectionEnabled?"none":"block",a.style.display=this.boundsDetectionEnabled?"block":"none",this.initialized&&this.boundsDetectionEnabled?(await r.startCapturing(this.config.utilizedTemplateNames.detect),this.toggleScanGuide(!0)):this.initialized&&!this.boundsDetectionEnabled&&this.stopCapturing()}async toggleSmartCapture(e){const t=C(this.config.container),i=t.children[t.children.length-1];if(!(null==i?void 0:i.shadowRoot))return;const n=i.shadowRoot.querySelector(".dce-mn-smart-capture"),a=i.shadowRoot.querySelector(".dce-mn-smart-capture-on"),s=i.shadowRoot.querySelector(".dce-mn-smart-capture-off");if(!a||!s)return;const o=void 0!==e?e:!this.smartCaptureEnabled;this.toggleAutoCaptureAnimation(o),o&&!this.boundsDetectionEnabled?await this.toggleBoundsDetection(!0):o||!1===this.config._showCorrectionView||await this.toggleAutoCrop(!1),this.smartCaptureEnabled=o,n.style.color=this.smartCaptureEnabled?"#fe814a":"#fff",s.style.display=this.smartCaptureEnabled?"none":"block",a.style.display=this.smartCaptureEnabled?"block":"none",this.crossVerificationCount=0}async toggleAutoCrop(e){const t=C(this.config.container),i=t.children[t.children.length-1];if(!(null==i?void 0:i.shadowRoot))return;const n=i.shadowRoot.querySelector(".dce-mn-auto-crop"),a=i.shadowRoot.querySelector(".dce-mn-auto-crop-on"),s=i.shadowRoot.querySelector(".dce-mn-auto-crop-off");if(!a||!s)return;const o=void 0!==e?e:!this.autoCropEnabled;!o||this.boundsDetectionEnabled&&this.smartCaptureEnabled||(await this.toggleBoundsDetection(!0),await this.toggleSmartCapture(!0)),o||!1!==this.config._showCorrectionView||await this.toggleSmartCapture(!1),this.autoCropEnabled=o,n.style.color=this.autoCropEnabled?"#fe814a":"#fff",s.style.display=this.autoCropEnabled?"none":"block",a.style.display=this.autoCropEnabled?"block":"none"}toggleScanGuide(e){var t,i;e&&!S(null===(i=null===(t=this.config)||void 0===t?void 0:t.scanRegion)||void 0===i?void 0:i.ratio)&&this.calculateScanRegion()}calculateScanRegion(){var e,t,i,n,a;const{cameraEnhancer:s,cameraView:o}=this.resources;if(!s||!s.isOpen())return;const r=o.getVisibleRegionOfVideo({inPixels:!0});if(!r)return;const l=o.getVideoElement(),c=l.videoWidth,d=l.videoHeight,h=null===(t=null===(e=this.config)||void 0===e?void 0:e.scanRegion)||void 0===t?void 0:t.ratio;let u;const m=null!==(a=null===(n=null===(i=this.config)||void 0===i?void 0:i.scanRegion)||void 0===n?void 0:n.regionBottomMargin)&&void 0!==a?a:0,g=r.height-m;if(r.width>r.height){u=.75*g/h.height;u*h.width>.9*r.width&&(u=.9*r.width/h.width)}else{u=.9*r.width/h.width;u*h.height>.75*g&&(u=.75*g/h.height)}const f=u*h.width,p=u*h.height,v=(r.width-f)/2,w=(g-p)/2,C=v,y=v+f,R=w,E=w+p,S=(r.x+C)/c*100,V=(r.x+y)/c*100,b=(r.y+R)/d*100,D=(r.y+E)/d*100,I={left:Math.round(S),right:Math.round(V),top:Math.round(b),bottom:Math.round(D),isMeasuredInPercentage:!0};null==o||o.setScanRegionMaskVisible(!0),s.setScanRegion(I)}async openCamera(){try{this.showScannerLoadingOverlay("Initializing camera...");const{cameraEnhancer:e,cameraView:t}=this.resources,i=C(this.config.container);if(i.style.display="block",e.isOpen())e.isPaused()&&await e.resume();else{const n=t.getUIElement();n.parentElement||i.append(n),await e.open()}await e.setResolution({width:2560,height:1440}),!this.initializedDCE&&e.isOpen()&&await this.initializeElements(),window.addEventListener("resize",this.handleResize),await this.toggleBoundsDetection(this.boundsDetectionEnabled),await this.toggleSmartCapture(this.smartCaptureEnabled),await this.toggleAutoCrop(this.autoCropEnabled)}catch(t){let i=(null==t?void 0:t.message)||t;console.error(i),alert(i),this.closeCamera();const n={status:{code:e.EnumResultStatus.RS_FAILED,message:"DDS Open Camera Error"}};this.currentScanResolver(n)}finally{this.hideScannerLoadingOverlay()}}closeCamera(e=!0){window.removeEventListener("resize",this.handleResize),this.resizeTimer&&(window.clearTimeout(this.resizeTimer),this.resizeTimer=null);const{cameraEnhancer:t,cameraView:i}=this.resources,n=C(this.config.container);n.style.display=e?"none":"block",i.getUIElement().parentElement&&n.removeChild(i.getUIElement()),t.close(),this.stopCapturing()}pauseCamera(){const{cameraEnhancer:e}=this.resources;e.pause()}stopCapturing(){const{cameraView:e,cvRouter:t}=this.resources;t.stopCapturing(),e.clearAllInnerDrawingItems()}getFlowType(){return this.autoCropEnabled?w.AUTO_CROP:this.smartCaptureEnabled?w.SMART_CAPTURE:w.MANUAL}async takePhoto(){var i,n,a,s;try{const{cameraEnhancer:o,onResultUpdated:r}=this.resources,l=!this.boundsDetectionEnabled||this.boundsDetectionEnabled&&(null===(i=this.capturedResultItems)||void 0===i?void 0:i.length)<=1;this.originalImageData=l?o.fetchImage():this.originalImageData;let c=null,d=null;if(l){this.capturedResultItems=[];const{width:e,height:t}=this.originalImageData;d={points:[{x:0,y:0},{x:e,y:0},{x:e,y:t},{x:0,y:t}],area:t*e}}else d=null===(n=this.capturedResultItems.find((e=>e.type===t.EnumCapturedResultItemType.CRIT_DETECTED_QUAD)))||void 0===n?void 0:n.location;S(null===(s=null===(a=this.config)||void 0===a?void 0:a.scanRegion)||void 0===s?void 0:s.ratio)||l||(d.points=d.points.map((e=>{var t;return(null===(t=this.resources.cameraEnhancer)||void 0===t?void 0:t.convertToScanRegionCoordinates(e))||e})));const h=this.getFlowType();await this.toggleSmartCapture(!1),this.closeCamera(),this.showScannerLoadingOverlay("Processing image..."),c=await this.normalizeImage(d.points,this.originalImageData),this.hideScannerLoadingOverlay(!0);const u={status:{code:e.EnumResultStatus.RS_SUCCESS,message:"Success"},originalImageResult:this.originalImageData,correctedImageResult:c,detectedQuadrilateral:d,_flowType:h};null==r||r(u),this.currentScanResolver(u)}catch(t){let i=(null==t?void 0:t.message)||t;console.error(i),alert(i),this.closeCamera();const n={status:{code:e.EnumResultStatus.RS_FAILED,message:"Error capturing image"}};this.currentScanResolver(n)}}async handleBoundsDetection(e){var i;if(this.capturedResultItems=e.items,!(null===(i=e.items)||void 0===i?void 0:i.length))return;const n=e.items.filter((e=>e.type===t.EnumCapturedResultItemType.CRIT_ORIGINAL_IMAGE));this.originalImageData=n.length&&n[0].imageData,(this.smartCaptureEnabled||this.autoCropEnabled)&&this.handleAutoCaptureMode(e)}async handleAutoCaptureMode(e){var t;e.items.length<=1?this.crossVerificationCount=0:(1===e.detectedQuadResultItems[0].crossVerificationStatus&&this.crossVerificationCount++,this.crossVerificationCount>=(null===(t=this.config)||void 0===t?void 0:t.minVerifiedFramesForAutoCapture)&&(this.crossVerificationCount=0,await this.takePhoto()))}async launch(){try{await this.initialize();const{cvRouter:e,cameraEnhancer:i}=this.resources;return new Promise((async n=>{this.currentScanResolver=n,await this.openCamera(),this.boundsDetectionEnabled&&await e.startCapturing(this.config.utilizedTemplateNames.detect),this.toggleScanGuide(!0),i.setPixelFormat(t.EnumImagePixelFormat.IPF_ABGR_8888),this.crossVerificationCount=0}))}catch(t){let i=(null==t?void 0:t.message)||t;console.error("DDS Launch error: ",i),this.closeCamera();const n={status:{code:e.EnumResultStatus.RS_FAILED,message:"DDS Launch error"}};this.currentScanResolver(n)}}async normalizeImage(e,t){var i;const{cvRouter:n,cameraEnhancer:a}=this.resources,s=await n.getSimplifiedSettings(this.config.utilizedTemplateNames.normalize);s.roiMeasuredInPercentage=!1,s.roi.points=e,await n.updateSettings(this.config.utilizedTemplateNames.normalize,s);const o=await n.capture(t,this.config.utilizedTemplateNames.normalize);if(null===(i=null==o?void 0:o.normalizedImageResultItems)||void 0===i?void 0:i[0])return o.normalizedImageResultItems[0]}}class _{constructor(e,t,i,n){this.resources=e,this.config=t,this.scannerView=i,this.correctionView=n}async launch(){try{return C(this.config.container).textContent="",await this.initialize(),C(this.config.container).style.display="flex",new Promise((e=>{this.currentScanResultViewResolver=e}))}catch(e){let t=(null==e?void 0:e.message)||e;throw console.error(t),t}}async handleUploadAndShareBtn(e){var t;try{const{result:i}=this.resources;if(!(null==i?void 0:i.correctedImageResult))throw new Error("No image to upload");"upload"===e&&(null===(t=this.config)||void 0===t?void 0:t.onUpload)?await this.config.onUpload(i):"share"===e&&await this.handleShare()}catch(e){console.error("Error on upload/share:",e),alert("Failed")}}async handleShare(){var e;try{const{result:t}=this.resources;if(!(null==t?void 0:t.correctedImageResult))throw new Error("No image result provided");const i=await t.correctedImageResult.toBlob("image/png");if(!i)throw new Error("Failed to convert image to blob");const n=new File([i],`document-${Date.now()}.png`,{type:i.type});if(navigator.share&&(null===(e=navigator.canShare)||void 0===e?void 0:e.call(navigator,{files:[n]})))await navigator.share({files:[n],title:"Dynamsoft Document Scanner Shared Image"});else{const e=URL.createObjectURL(i),t=document.createElement("a");t.href=e,t.download=n.name,document.body.appendChild(t),t.click(),document.body.removeChild(t),URL.revokeObjectURL(e)}return!0}catch(e){if("AbortError"!==e.name){let t=(null==e?void 0:e.message)||e;console.error("Error sharing image:",t),alert(`Error sharing image: ${t}`)}}}async handleCorrectImage(){try{if(!this.correctionView)return void console.error("Correction View not initialized");this.hideView();const e=await this.correctionView.launch();e.correctedImageResult&&(this.resources.onResultUpdated&&this.resources.onResultUpdated(Object.assign(Object.assign({},this.resources.result),{correctedImageResult:e.correctedImageResult})),this.dispose(!0),await this.initialize(),C(this.config.container).style.display="flex")}catch(t){throw console.error("DocumentResultView - Handle Correction View Error:",t),this.currentScanResultViewResolver&&this.currentScanResultViewResolver({status:{code:e.EnumResultStatus.RS_FAILED,message:(null==t?void 0:t.message)||t}}),t}}async handleRetake(){var t;try{if(!this.scannerView)return void console.error("Correction View not initialized");this.hideView();const i=await this.scannerView.launch();if((null===(t=null==i?void 0:i.status)||void 0===t?void 0:t.code)===e.EnumResultStatus.RS_FAILED)return void(this.currentScanResultViewResolver&&this.currentScanResultViewResolver(i));this.resources.onResultUpdated&&((null==i?void 0:i.status.code)===e.EnumResultStatus.RS_CANCELLED?this.resources.onResultUpdated(this.resources.result):(null==i?void 0:i.status.code)===e.EnumResultStatus.RS_SUCCESS&&this.resources.onResultUpdated(i)),this.correctionView&&(null==i?void 0:i._flowType)&&R(null==i?void 0:i._flowType)&&await this.handleCorrectImage(),this.dispose(!0),await this.initialize(),C(this.config.container).style.display="flex"}catch(t){throw console.error("Error in retake handler:",t),this.currentScanResultViewResolver&&this.currentScanResultViewResolver({status:{code:e.EnumResultStatus.RS_FAILED,message:(null==t?void 0:t.message)||t}}),t}}async handleDone(){var t;try{(null===(t=this.config)||void 0===t?void 0:t.onDone)&&await this.config.onDone(this.resources.result),this.currentScanResultViewResolver&&this.resources.result&&this.currentScanResultViewResolver(this.resources.result),this.hideView(),this.dispose()}catch(t){throw console.error("Error in done handler:",t),this.currentScanResultViewResolver&&this.currentScanResultViewResolver({status:{code:e.EnumResultStatus.RS_FAILED,message:(null==t?void 0:t.message)||t}}),t}}createControls(){var e,t,i,n,a,s,o,r,l,c,d,h,u,m,g,f,p,v,w,C;const{toolbarButtonsConfig:R,onUpload:E}=this.config,S=new Blob(["mock-png-data"],{type:"image/png"}),V=new File([S],"test.png",{type:"image/png"}),D="share"in navigator&&navigator.canShare({files:[V]});return y([{id:"dds-scanResult-retake",icon:(null===(e=null==R?void 0:R.retake)||void 0===e?void 0:e.icon)||b.retake,label:(null===(t=null==R?void 0:R.retake)||void 0===t?void 0:t.label)||"Re-take",onClick:()=>this.handleRetake(),className:`${(null===(i=null==R?void 0:R.retake)||void 0===i?void 0:i.className)||""}`,isHidden:(null===(n=null==R?void 0:R.retake)||void 0===n?void 0:n.isHidden)||!1,isDisabled:!this.scannerView},{id:"dds-scanResult-correct",icon:(null===(a=null==R?void 0:R.correct)||void 0===a?void 0:a.icon)||b.normalize,label:(null===(s=null==R?void 0:R.correct)||void 0===s?void 0:s.label)||"Correction",onClick:()=>this.handleCorrectImage(),className:`${(null===(o=null==R?void 0:R.correct)||void 0===o?void 0:o.className)||""}`,isHidden:(null===(r=null==R?void 0:R.correct)||void 0===r?void 0:r.isHidden)||!1,isDisabled:!this.correctionView},{id:"dds-scanResult-share",icon:(null===(l=null==R?void 0:R.share)||void 0===l?void 0:l.icon)||(D?b.share:b.downloadPNG),label:(null===(c=null==R?void 0:R.share)||void 0===c?void 0:c.label)||(D?"Share":"Download"),className:`${(null===(d=null==R?void 0:R.share)||void 0===d?void 0:d.className)||""}`,isHidden:(null===(h=null==R?void 0:R.share)||void 0===h?void 0:h.isHidden)||!1,onClick:()=>this.handleUploadAndShareBtn("share")},{id:"dds-scanResult-upload",icon:(null===(u=null==R?void 0:R.upload)||void 0===u?void 0:u.icon)||b.upload,label:(null===(m=null==R?void 0:R.upload)||void 0===m?void 0:m.label)||"Upload",className:`${(null===(g=null==R?void 0:R.upload)||void 0===g?void 0:g.className)||""}`,isHidden:!E||((null===(f=null==R?void 0:R.upload)||void 0===f?void 0:f.isHidden)||!1),isDisabled:!E,onClick:()=>this.handleUploadAndShareBtn("upload")},{id:"dds-scanResult-done",icon:(null===(p=null==R?void 0:R.done)||void 0===p?void 0:p.icon)||b.complete,label:(null===(v=null==R?void 0:R.done)||void 0===v?void 0:v.label)||"Done",className:`${(null===(w=null==R?void 0:R.done)||void 0===w?void 0:w.className)||""}`,isHidden:(null===(C=null==R?void 0:R.done)||void 0===C?void 0:C.isHidden)||!1,onClick:()=>this.handleDone()}])}async initialize(){var e;try{if(!this.resources.result)throw Error("Captured image is missing. Please capture an image first!");if(!this.config.container)throw new Error("Please create a Scan Result View Container element");E("dds-result-view-style",x);const t=document.createElement("div");t.className="dds-result-view-container";const i=document.createElement("div");Object.assign(i.style,{width:"100%",height:"100%",display:"flex",alignItems:"center",justifyContent:"center",minHeight:"0"});const n=null===(e=this.resources.result.correctedImageResult)||void 0===e?void 0:e.toCanvas();Object.assign(n.style,{maxWidth:"100%",maxHeight:"100%",objectFit:"contain"}),i.appendChild(n),t.appendChild(i);const a=this.createControls();if(t.appendChild(a),C(this.config.container).appendChild(t),this.resources.result._flowType===w.STATIC_FILE){document.querySelector("#dds-scanResult-retake").style.display="none"}}catch(e){let t=(null==e?void 0:e.message)||e;console.error(t),alert(t)}}hideView(){C(this.config.container).style.display="none"}dispose(e=!1){C(this.config.container).textContent="",e||(this.currentScanResultViewResolver=void 0)}}const x="\n  .dds-result-view-container {\n    display: flex;\n    width: 100%;\n    height: 100%;\n    background-color:#575757;\n    font-size: 12px;\n    flex-direction: column;\n    align-items: center;\n  }\n\n  @media (orientation: landscape) and (max-width: 1024px) {\n    .dds-result-view-container {\n      flex-direction: row;\n    }\n  }\n",T={rootDirectory:"https://cdn.jsdelivr.net/npm/"};class L{showScannerLoadingOverlay(e){const t=C(this.config.scannerViewConfig.container);this.loadingScreen=P(t,{message:e}),t.style.display="block",t.style.position="relative"}hideScannerLoadingOverlay(e=!1){if(this.loadingScreen&&(this.loadingScreen.hide(),this.loadingScreen=null,e)){C(this.config.scannerViewConfig.container).style.display="none"}}constructor(e){this.config=e,this.resources={},this.isInitialized=!1,this.isCapturing=!1,this.loadingScreen=null}async initialize(){if(this.isInitialized)return{resources:this.resources,components:{scannerView:this.scannerView,correctionView:this.correctionView,scanResultView:this.scanResultView}};try{this.initializeDDSConfig(),await this.initializeDCVResources(),this.resources.onResultUpdated=e=>{this.resources.result=e};const e={};return this.config.scannerViewConfig&&(this.scannerView=new A(this.resources,this.config.scannerViewConfig),e.scannerView=this.scannerView,await this.scannerView.initialize()),this.config.correctionViewConfig&&(this.correctionView=new D(this.resources,this.config.correctionViewConfig,this.scannerView),e.correctionView=this.correctionView),this.config.resultViewConfig&&(this.scanResultView=new _(this.resources,this.config.resultViewConfig,this.scannerView,this.correctionView),e.scanResultView=this.scanResultView),this.isInitialized=!0,{resources:this.resources,components:e}}catch(e){this.isInitialized=!1;let t=(null==e?void 0:e.message)||e;throw new Error(`Initialization Failed: ${t}`)}}async initializeDCVResources(){var e,s,o;try{t.CoreModule.engineResourcePaths=S(null===(e=this.config)||void 0===e?void 0:e.engineResourcePaths)?T:this.config.engineResourcePaths,i.LicenseManager._onAuthMessage=e=>e.replace("(https://www.dynamsoft.com/customer/license/trialLicense?product=unknown&deploymenttype=unknown)","(https://www.dynamsoft.com/customer/license/trialLicense?product=mwc&deploymenttype=web)"),i.LicenseManager.initLicense((null===(s=this.config)||void 0===s?void 0:s.license)||"",!0),t.CoreModule.loadWasm(["DDN"]),this.resources.cameraView=await a.CameraView.createInstance(null===(o=this.config.scannerViewConfig)||void 0===o?void 0:o.cameraEnhancerUIPath),this.resources.cameraEnhancer=await a.CameraEnhancer.createInstance(this.resources.cameraView),this.resources.cvRouter=await n.CaptureVisionRouter.createInstance()}catch(e){let t=(null==e?void 0:e.message)||e;throw new Error(`Resource Initialization Failed: ${t}`)}}shouldCreateDefaultContainer(){var e,t,i;const n=!this.config.container,a=!((null===(e=this.config.scannerViewConfig)||void 0===e?void 0:e.container)||(null===(t=this.config.resultViewConfig)||void 0===t?void 0:t.container)||(null===(i=this.config.correctionViewConfig)||void 0===i?void 0:i.container));return n&&a}createDefaultDDSContainer(){const e=document.createElement("div");return e.className="dds-main-container",Object.assign(e.style,{display:"none",height:"100dvh",width:"100%",position:"absolute",left:"0",top:"0",zIndex:"999"}),document.body.append(e),e}checkForTemporaryLicense(e){return!(null==e?void 0:e.length)||(null==e?void 0:e.startsWith("A"))||(null==e?void 0:e.startsWith("L"))||(null==e?void 0:e.startsWith("P"))||(null==e?void 0:e.startsWith("Y"))?"DLS2eyJvcmdhbml6YXRpb25JRCI6IjIwMDAwMSJ9":e}validateViewConfigs(){var e,t;if(!this.config.container){if(this.config.showCorrectionView&&!(null===(e=this.config.correctionViewConfig)||void 0===e?void 0:e.container))throw new Error("CorrectionView container is required when showCorrectionView is true and no main container is provided");if(this.config.showResultView&&!(null===(t=this.config.resultViewConfig)||void 0===t?void 0:t.container))throw new Error("ResultView container is required when showResultView is true and no main container is provided")}}showCorrectionView(){var e,t;return!1!==this.config.showCorrectionView&&(this.config.container?!(void 0!==this.config.showCorrectionView||!(null===(e=this.config.correctionViewConfig)||void 0===e?void 0:e.container)&&!this.config.container)||!!this.config.showCorrectionView:this.config.showCorrectionView&&!!(null===(t=this.config.correctionViewConfig)||void 0===t?void 0:t.container))}showResultView(){var e,t;return!1!==this.config.showResultView&&(this.config.container?!(void 0!==this.config.showResultView||!(null===(e=this.config.resultViewConfig)||void 0===e?void 0:e.container)&&!this.config.container)||!!this.config.showResultView:this.config.showResultView&&!!(null===(t=this.config.resultViewConfig)||void 0===t?void 0:t.container))}initializeDDSConfig(){var e,t,i,n,a,s,o;this.validateViewConfigs(),this.shouldCreateDefaultContainer()?this.config.container=this.createDefaultDDSContainer():this.config.container&&(this.config.container=C(this.config.container));const r=this.config.container?this.createViewContainers(C(this.config.container)):{},c={license:this.checkForTemporaryLicense(this.config.license),utilizedTemplateNames:{detect:(null===(e=this.config.utilizedTemplateNames)||void 0===e?void 0:e.detect)||f,normalize:(null===(t=this.config.utilizedTemplateNames)||void 0===t?void 0:t.normalize)||p},templateFilePath:(null===(i=this.config)||void 0===i?void 0:i.templateFilePath)||null},d=Object.assign(Object.assign({},this.config.scannerViewConfig),{container:r[l.Scanner]||(null===(n=this.config.scannerViewConfig)||void 0===n?void 0:n.container)||null,cameraEnhancerUIPath:(null===(a=this.config.scannerViewConfig)||void 0===a?void 0:a.cameraEnhancerUIPath)||"https://cdn.jsdelivr.net/npm/dynamsoft-document-scanner@1.2.0/dist/document-scanner.ui.html",templateFilePath:c.templateFilePath,utilizedTemplateNames:c.utilizedTemplateNames,_showCorrectionView:this.showCorrectionView()}),h=this.showCorrectionView()?Object.assign(Object.assign({},this.config.correctionViewConfig),{container:r[l.Correction]||(null===(s=this.config.correctionViewConfig)||void 0===s?void 0:s.container)||null,templateFilePath:c.templateFilePath,utilizedTemplateNames:c.utilizedTemplateNames,_showResultView:this.showResultView()}):void 0,u=this.showResultView()?Object.assign(Object.assign({},this.config.resultViewConfig),{container:r[l.Result]||(null===(o=this.config.resultViewConfig)||void 0===o?void 0:o.container)||null}):void 0;Object.assign(this.config,Object.assign(Object.assign({},c),{scannerViewConfig:d,correctionViewConfig:h,resultViewConfig:u}))}createViewContainers(e){e.textContent="";const t=[l.Scanner];return this.showCorrectionView()&&t.push(l.Correction),this.showResultView()&&t.push(l.Result),t.reduce(((t,i)=>{const n=document.createElement("div");return n.className=`dds-${i}-view-container`,Object.assign(n.style,{height:"100%",width:"100%",display:"none",position:"relative"}),e.append(n),t[i]=n,t}),{})}dispose(){var e,t,i;this.scanResultView&&(this.scanResultView.dispose(),this.scanResultView=null),this.correctionView&&(this.correctionView.dispose(),this.correctionView=null),this.scannerView=null,this.resources.cameraEnhancer&&(this.resources.cameraEnhancer.dispose(),this.resources.cameraEnhancer=null),this.resources.cameraView&&(this.resources.cameraView.dispose(),this.resources.cameraView=null),this.resources.cvRouter&&(this.resources.cvRouter.dispose(),this.resources.cvRouter=null),this.resources.result=null,this.resources.onResultUpdated=null;const n=e=>{const t=C(e);t&&(t.style.display="none",t.textContent="")};n(this.config.container),n(null===(e=this.config.scannerViewConfig)||void 0===e?void 0:e.container),n(null===(t=this.config.correctionViewConfig)||void 0===t?void 0:t.container),n(null===(i=this.config.resultViewConfig)||void 0===i?void 0:i.container),this.isInitialized=!1}async processFileToBlob(e){return new Promise(((t,i)=>{if(!e.type.startsWith("image/"))return void i(new Error("Please select an image file"));const n=new Image;n.onload=()=>{const a=document.createElement("canvas");a.width=n.width,a.height=n.height;const s=a.getContext("2d");null==s||s.drawImage(n,0,0),a.toBlob((e=>{e?t({blob:e,width:n.width,height:n.height}):i(new Error("Failed to create blob from image"))}),e.type)},n.onerror=()=>i(new Error("Failed to load image")),n.src=URL.createObjectURL(e)}))}async processUploadedFile(i){var n,a,s,o,r;try{this.showScannerLoadingOverlay("Processing image...");const{blob:l}=await this.processFileToBlob(i),c=(await this.resources.cvRouter.capture(l,this.config.utilizedTemplateNames.detect)).items,d=null===(n=c[0])||void 0===n?void 0:n.imageData;if(!d)throw new Error("Failed to extract image data");let h;if(c.length<=1){const{width:e,height:t}=d;h={points:[{x:0,y:0},{x:e,y:0},{x:e,y:t},{x:0,y:t}],area:t*e}}else h=null===(a=c.find((e=>e.type===t.EnumCapturedResultItemType.CRIT_DETECTED_QUAD)))||void 0===a?void 0:a.location;const u=await this.resources.cvRouter.getSimplifiedSettings(this.config.utilizedTemplateNames.normalize);u.roiMeasuredInPercentage=!1,u.roi.points=h.points,await this.resources.cvRouter.updateSettings(this.config.utilizedTemplateNames.normalize,u);const m=await this.resources.cvRouter.capture(d,this.config.utilizedTemplateNames.normalize),g=null===(s=null==m?void 0:m.normalizedImageResultItems)||void 0===s?void 0:s[0],f={status:{code:e.EnumResultStatus.RS_SUCCESS,message:"Success"},originalImageResult:d,correctedImageResult:g,detectedQuadrilateral:h,_flowType:w.STATIC_FILE};null===(r=(o=this.resources).onResultUpdated)||void 0===r||r.call(o,f),this.hideScannerLoadingOverlay(!0)}catch(t){return console.error("Failed to process uploaded file:",t),{status:{code:e.EnumResultStatus.RS_FAILED,message:`Failed to process image: ${t.message||t}`}}}}async launch(t){if(this.isCapturing)throw new Error("Capture session already in progress");try{this.isCapturing=!0;const{components:i}=await this.initialize();if(this.config.container&&(C(this.config.container).style.display="block"),t&&(i.scannerView=null,await this.processUploadedFile(t)),!i.scannerView&&this.resources.result){if(i.correctionView&&!i.scanResultView)return await i.correctionView.launch();if(i.scanResultView&&!i.correctionView)return await i.scanResultView.launch();if(i.scanResultView&&i.correctionView)return await i.correctionView.launch(),await i.scanResultView.launch()}if(!i.scannerView&&!this.resources.result)throw new Error("Scanner view is required when no previous result exists");if(i.scannerView){const t=await i.scannerView.launch();if((null==t?void 0:t.status.code)!==e.EnumResultStatus.RS_SUCCESS)return{status:{code:null==t?void 0:t.status.code,message:(null==t?void 0:t.status.message)||"Failed to capture image"}};if(i.correctionView&&i.scanResultView&&R(t._flowType))return await i.correctionView.launch(),await i.scanResultView.launch();if(i.correctionView&&!i.scanResultView)return await i.correctionView.launch();if(i.scanResultView)return await i.scanResultView.launch()}return this.resources.result}catch(t){return console.error("Document capture flow failed:",(null==t?void 0:t.message)||t),{status:{code:e.EnumResultStatus.RS_FAILED,message:`Document capture flow failed. ${(null==t?void 0:t.message)||t}`}}}finally{this.isCapturing=!1,this.dispose()}}}const z={DocumentScanner:L,DocumentNormalizerView:D,DocumentScannerView:A,DocumentResultView:_,EnumResultStatus:e.EnumResultStatus,EnumFlowType:w,EnumDDSViews:l};e.Core=c,e.License=d,e.CVR=h,e.DCE=u,e.DDN=m,e.Utility=g,e.DDS=z,e.DocumentNormalizerView=D,e.DocumentResultView=_,e.DocumentScanner=L,e.DocumentScannerView=A}));
